searchNodes=[{"doc":"Public API Before using for the first time: $ mix amnesia.create -d Markov.Database --disk Example workflow: # The name can be an arbitrary term (not just a string). # It will be stored in a Mnesia DB and created from scratch using the specified # parameters if not found. # You should configure mnesia if you want to change its working dir, e.g.: # `config :mnesia, dir: &quot;/var/data&quot;` { :ok , model } = Markov . load ( &quot;model_name&quot; , sanitize_tokens : true , store_log : [ :train ] ) # train using four strings :ok = Markov . train ( model , &quot;hello, world!&quot; ) :ok = Markov . train ( model , &quot;example string number two&quot; ) :ok = Markov . train ( model , &quot;hello, Elixir!&quot; ) :ok = Markov . train ( model , &quot;fourth string&quot; ) # generate text { :ok , text } = Markov . generate_text ( model ) IO . puts ( text ) # commit all changes and unload Markov . unload ( model ) # these will return errors because the model is unloaded # Markov.generate_text(model) # Markov.train(model, &quot;hello, world!&quot;) # load the model again { :ok , model } = Markov . load ( &quot;/base/directory&quot; , &quot;model_name&quot; ) # enable probability shifting and generate text :ok = Markov . configure ( model , shift_probabilities : true ) { :ok , text } = Markov . generate_text ( model ) IO . puts ( text ) # print uninteresting stats model |&gt; Markov . dump_partition ( 0 ) |&gt; IO . inspect model |&gt; Markov . read_log |&gt; IO . inspect # this will also write our new just-set option Markov . unload ( model )","ref":"Markov.html","title":"Markov","type":"module"},{"doc":"Reconfigures an already loaded model. See model_option/0 for a thorough description of the options","ref":"Markov.html#configure/2","title":"Markov.configure/2","type":"function"},{"doc":"Reads the model for debugging purposes","ref":"Markov.html#dump_model/1","title":"Markov.dump_model/1","type":"function"},{"doc":"Predicts (generates) a string. Will raise an exception if the model was trained on non-textual tokens at least once iex&gt; Markov . generate_text ( model ) { :ok , &quot;hello world&quot; } See type tag_query/0 for more info about tags","ref":"Markov.html#generate_text/2","title":"Markov.generate_text/2","type":"function"},{"doc":"Predicts (generates) a list of tokens iex&gt; Markov . generate_tokens ( model ) { :ok , [ &quot;hello&quot; , &quot;world&quot; ] } See type tag_query/0 for more info about tag_query","ref":"Markov.html#generate_tokens/2","title":"Markov.generate_tokens/2","type":"function"},{"doc":"Gets the configuration of an already loaded model","ref":"Markov.html#get_config/1","title":"Markov.get_config/1","type":"function"},{"doc":"Loads an existing model named name . If none is found, a new model with the specified options will be created and loaded, and if that fails, an error will be returned.","ref":"Markov.html#load/2","title":"Markov.load/2","type":"function"},{"doc":"Deletes model data forever. There's no going back!","ref":"Markov.html#nuke/1","title":"Markov.nuke/1","type":"function"},{"doc":"Reads the log file and returns a list of entries in chronological order iex&gt; Markov . read_log ( model ) { :ok , [ % Operation { date_time : ~U[2022-10-02 16:59:51.844Z] , type : :start , arg : nil } , % Operation { date_time : ~U[2022-10-02 16:59:56.705Z] , type : :train , arg : [ &quot;hello&quot; , &quot;world&quot; ] } ] }","ref":"Markov.html#read_log/1","title":"Markov.read_log/1","type":"function"},{"doc":"Trains model using text or a list of tokens. :ok = Markov . train ( model , &quot;Hello, world!&quot; ) :ok = Markov . train ( model , &quot;this is a string that&#39;s broken down into tokens behind the scenes&quot; ) :ok = Markov . train ( model , [ :this , &quot;is&quot; , &#39;a token&#39; , :list , &quot;where&quot; , { :each_element , :is , { :taken , :as_is } } , :and , :can_be , :erlang . make_ref ( ) , &quot;&lt;-- any term&quot; ] ) See generate_text/2 for more info about tags","ref":"Markov.html#train/3","title":"Markov.train/3","type":"function"},{"doc":"Unloads an already loaded model","ref":"Markov.html#unload/1","title":"Markov.unload/1","type":"function"},{"doc":"","ref":"Markov.html#t:log_entry_type/0","title":"Markov.log_entry_type/0","type":"type"},{"doc":"Model options that could be set during creation in a call to load/3 or with configure/2 : store_log : determines what data to put in the operation log, all of them by default: :start - model is loaded :end - model is unloaded :train : training requests :gen : generation results shift_probabilities : gives less popular generation paths more chance to get used, which makes the output more original but may produce nonsense; false by default sanitize_tokens : ignores letter case and punctuation when switching states, but still keeps the output as-is; false by default, can't be changed once the model is created order : order of the chain, i.e. how many previous tokens the next one is based on; 2 by default, can never be changed once the model is created","ref":"Markov.html#t:model_option/0","title":"Markov.model_option/0","type":"type"},{"doc":"","ref":"Markov.html#t:model_reference/0","title":"Markov.model_reference/0","type":"opaque"},{"doc":"If data was tagged when training, you can use tag queries to only select generation paths that match a set of criteria true always matches {x, :or, y} matches when either x or y matches {:not, x} matches if x doesn't match, and vice versa {x, :score, y} is only allowed at the top level; the total score counter (initially 0) is increased by score for every element {query, score} of y (a list) that matches; probabilities are then adjusted according to those scores. any other term is treated as a tag (note the :&quot;$none&quot; tag - the default one) Examples: # training iex&gt; Markov . train ( model , &quot;hello earth&quot; , [ { :action , :saying_hello } , # &lt;- terms of any type can function as tags { :subject_type , :planet } , { :subject , &quot;earth&quot; } , :lowercase ] ) :ok iex&gt; Markov . train ( model , &quot;Hello Elixir&quot; , [ { :action , :saying_hello } , { :subject_type , :programming_language } , { :subject , &quot;Elixir&quot; } , :uppercase ] ) :ok # simple generation - both paths have equal probabilities iex&gt; Markov . generate_text ( model ) { :ok , &quot;hello earth&quot; } iex&gt; Markov . generate_text ( model ) { :ok , &quot;hello Elixir&quot; } # simple tag queries iex&gt; Markov . generate_text ( model , { :subject_type , :planet } ) { :ok , &quot;hello earth&quot; } iex&gt; Markov . generate_text ( model , :lowercase ) { :ok , &quot;hello earth&quot; } iex&gt; Markov . generate_text ( model , { :subject_type , :programming_language } ) { :ok , &quot;hello Elixir&quot; } iex&gt; Markov . generate_text ( model , :uppercase ) { :ok , &quot;hello Elixir&quot; } # both possible generation paths were tagged with this tag iex&gt; Markov . generate_text ( model , { :action , :saying_hello } ) { :ok , &quot;hello earth&quot; } iex&gt; Markov . generate_text ( model , { :action , :saying_hello } ) { :ok , &quot;hello Elixir&quot; } # both paths match, but &quot;hello Elixir&quot; has a score of 1 and &quot;hello earth&quot; # has a score of zero; thus, &quot;hello Elixir&quot; has a probability of 2/3, and # &quot;hello earth&quot; has that of 1/3 iex&gt; Markov . generate_text ( model , { true , :score , [ :uppercase ] } ) { :ok , &quot;hello Elixir&quot; } iex&gt; Markov . generate_text ( model , { true , :score , [ :uppercase ] } ) { :ok , &quot;hello earth&quot; }","ref":"Markov.html#t:tag_query/0","title":"Markov.tag_query/0","type":"type"},{"doc":"Markov OTP app","ref":"Markov.App.html","title":"Markov.App","type":"module"},{"doc":"","ref":"Markov.Database.html","title":"Markov.Database","type":"module"},{"doc":"Alias all the table names in the current scope and require what's needed.","ref":"Markov.Database.html#__using__/1","title":"Markov.Database.__using__/1","type":"macro"},{"doc":"Create the database, it calls .create on every defined table, raises in case of error.","ref":"Markov.Database.html#create!/1","title":"Markov.Database.create!/1","type":"function"},{"doc":"Create the database, it calls .create on every defined table.","ref":"Markov.Database.html#create/1","title":"Markov.Database.create/1","type":"function"},{"doc":"Destroy the database, it calls .destroy on every defined table, raises in case of error.","ref":"Markov.Database.html#destroy!/0","title":"Markov.Database.destroy!/0","type":"function"},{"doc":"Destroy the database, it calls .destroy on every defined table.","ref":"Markov.Database.html#destroy/0","title":"Markov.Database.destroy/0","type":"function"},{"doc":"","ref":"Markov.Database.html#metadata/0","title":"Markov.Database.metadata/0","type":"function"},{"doc":"List of atoms of the defined tables in the database.","ref":"Markov.Database.html#tables/0","title":"Markov.Database.tables/0","type":"function"},{"doc":"Wait for the database to be loaded.","ref":"Markov.Database.html#wait/1","title":"Markov.Database.wait/1","type":"function"},{"doc":"","ref":"Markov.Database.Link.html","title":"Markov.Database.Link","type":"module"},{"doc":"Require the needed modules to use the table effectively.","ref":"Markov.Database.Link.html#__using__/1","title":"Markov.Database.Link.__using__/1","type":"macro"},{"doc":"Add a copy of the table on the given node with the given mode.","ref":"Markov.Database.Link.html#add_copy/2","title":"Markov.Database.Link.add_copy/2","type":"function"},{"doc":"Add the index in the table for the given attribute.","ref":"Markov.Database.Link.html#add_index/1","title":"Markov.Database.Link.add_index/1","type":"function"},{"doc":"Read a record based on a slot, see mnesia:dirty_slot .","ref":"Markov.Database.Link.html#at!/1","title":"Markov.Database.Link.at!/1","type":"function"},{"doc":"The in order keyword list of attributes passed when the table was defined.","ref":"Markov.Database.Link.html#attributes/0","title":"Markov.Database.Link.attributes/0","type":"function"},{"doc":"Check if the table is a bag.","ref":"Markov.Database.Link.html#bag?/0","title":"Markov.Database.Link.bag?/0","type":"function"},{"doc":"Clear the content of the table.","ref":"Markov.Database.Link.html#clear/0","title":"Markov.Database.Link.clear/0","type":"function"},{"doc":"Change the copying mode of the table on the given node, see mnesia:change_table_copy_type . Modes :disk sets :disc_copies mode :disk! sets :disc_only_copies mode :memory sets :ram_copies mode","ref":"Markov.Database.Link.html#copying/2","title":"Markov.Database.Link.copying/2","type":"function"},{"doc":"Get the number of records in the table.","ref":"Markov.Database.Link.html#count/0","title":"Markov.Database.Link.count/0","type":"function"},{"doc":"","ref":"Markov.Database.Link.html#create!/1","title":"Markov.Database.Link.create!/1","type":"function"},{"doc":"Create the table with the given copying mode and inherent definition.","ref":"Markov.Database.Link.html#create/1","title":"Markov.Database.Link.create/1","type":"function"},{"doc":"Return the database the table belongs to.","ref":"Markov.Database.Link.html#database/0","title":"Markov.Database.Link.database/0","type":"function"},{"doc":"Delete the record or the given key from the table, see mnesia:dirty_delete and mnesia:dirty_delete_object .","ref":"Markov.Database.Link.html#delete!/1","title":"Markov.Database.Link.delete!/1","type":"function"},{"doc":"Delete the record or the given key from the table, see mnesia:delete and mnesia:delete_object .","ref":"Markov.Database.Link.html#delete/1","title":"Markov.Database.Link.delete/1","type":"function"},{"doc":"Delete the record or the given key from the table with the given lock, see mnesia:delete and mnesia:delete_object . Locks :write sets a :write lock :write! sets a :sticky_write lock","ref":"Markov.Database.Link.html#delete/2","title":"Markov.Database.Link.delete/2","type":"function"},{"doc":"Delete a copy of the table from the given node.","ref":"Markov.Database.Link.html#delete_copy/1","title":"Markov.Database.Link.delete_copy/1","type":"function"},{"doc":"Delete the index in the table for the given attribute.","ref":"Markov.Database.Link.html#delete_index/1","title":"Markov.Database.Link.delete_index/1","type":"function"},{"doc":"Destroy the table, raising if an error occurs.","ref":"Markov.Database.Link.html#destroy!/0","title":"Markov.Database.Link.destroy!/0","type":"function"},{"doc":"Destroy the table.","ref":"Markov.Database.Link.html#destroy/0","title":"Markov.Database.Link.destroy/0","type":"function"},{"doc":"Return the first key or record in the table, see mnesia:dirty_first . By default it returns the record, if you want only the key pass true as first parameter. If the table is a bag, it will return a list of records.","ref":"Markov.Database.Link.html#first!/1","title":"Markov.Database.Link.first!/1","type":"function"},{"doc":"Return the first key or record in the table, see mnesia:first . By default it returns the record, if you want only the key pass true as first parameter. If the table is a bag, it will return a list of records.","ref":"Markov.Database.Link.html#first/2","title":"Markov.Database.Link.first/2","type":"function"},{"doc":"Fold the whole table from the left, see mnesia:foldl .","ref":"Markov.Database.Link.html#foldl/2","title":"Markov.Database.Link.foldl/2","type":"function"},{"doc":"Fold the whole table from the right, see mnesia:foldr .","ref":"Markov.Database.Link.html#foldr/2","title":"Markov.Database.Link.foldr/2","type":"function"},{"doc":"Force load the table.","ref":"Markov.Database.Link.html#force/0","title":"Markov.Database.Link.force/0","type":"function"},{"doc":"","ref":"Markov.Database.Link.html#hook_read!/2","title":"Markov.Database.Link.hook_read!/2","type":"function"},{"doc":"","ref":"Markov.Database.Link.html#hook_read/2","title":"Markov.Database.Link.hook_read/2","type":"function"},{"doc":"","ref":"Markov.Database.Link.html#hook_write!/1","title":"Markov.Database.Link.hook_write!/1","type":"function"},{"doc":"","ref":"Markov.Database.Link.html#hook_write/1","title":"Markov.Database.Link.hook_write/1","type":"function"},{"doc":"Get the name of the id key.","ref":"Markov.Database.Link.html#id/0","title":"Markov.Database.Link.id/0","type":"function"},{"doc":"Get information about the table, see mnesia:table_info .","ref":"Markov.Database.Link.html#info/1","title":"Markov.Database.Link.info/1","type":"function"},{"doc":"Return the key of the record.","ref":"Markov.Database.Link.html#key/1","title":"Markov.Database.Link.key/1","type":"function"},{"doc":"Return all keys in the table, see mnesia:dirty_all_keys .","ref":"Markov.Database.Link.html#keys!/0","title":"Markov.Database.Link.keys!/0","type":"function"},{"doc":"Return all the keys in the table, see mnesia:all_keys .","ref":"Markov.Database.Link.html#keys/0","title":"Markov.Database.Link.keys/0","type":"function"},{"doc":"Return the last key or record in the table, see mnesia:dirty_last . By default it returns the record, if you want only the key pass true as first parameter. If the table is a bag, it will return a list of records.","ref":"Markov.Database.Link.html#last!/1","title":"Markov.Database.Link.last!/1","type":"function"},{"doc":"Return the last key or record in the table, see mnesia:last . By default it returns the record, if you want only the key pass true as first parameter. If the table is a bag, it will return a list of records.","ref":"Markov.Database.Link.html#last/2","title":"Markov.Database.Link.last/2","type":"function"},{"doc":"Lock the table with the given lock. Locks :write sets a :write lock :write! sets a :sticky_write lock :read sets a :read lock","ref":"Markov.Database.Link.html#lock/1","title":"Markov.Database.Link.lock/1","type":"function"},{"doc":"Change the table majority.","ref":"Markov.Database.Link.html#majority/1","title":"Markov.Database.Link.majority/1","type":"function"},{"doc":"Set master nodes for the table, see mnesia:set_master_nodes .","ref":"Markov.Database.Link.html#master_nodes/1","title":"Markov.Database.Link.master_nodes/1","type":"function"},{"doc":"Select records in the table using simple don't care values, see mnesia:dirty_match_object .","ref":"Markov.Database.Link.html#match!/1","title":"Markov.Database.Link.match!/1","type":"function"},{"doc":"Select records in the table using simple don't care values, see mnesia:match_object .","ref":"Markov.Database.Link.html#match/2","title":"Markov.Database.Link.match/2","type":"function"},{"doc":"Check if the key is present in the table.","ref":"Markov.Database.Link.html#member?/1","title":"Markov.Database.Link.member?/1","type":"function"},{"doc":"Change the access of the table, see mnesia:change_table_access_mode . Modes :both sets read and write mode, it's the default. :read! sets read-only mode.","ref":"Markov.Database.Link.html#mode/1","title":"Markov.Database.Link.mode/1","type":"function"},{"doc":"Move a copy of the table from the given node to another given node.","ref":"Markov.Database.Link.html#move_copy/2","title":"Markov.Database.Link.move_copy/2","type":"function"},{"doc":"Return the next key or record in the table, see mnesia:dirty_next . If you're calling this function from an instance of the table (a record in it), it will get you the next record, if you're calling it directly on the module it will treat the argument as key to start from and return you the next key.","ref":"Markov.Database.Link.html#next!/1","title":"Markov.Database.Link.next!/1","type":"function"},{"doc":"Return the next key or record in the table, see mnesia:next . If you're calling this function from an instance of the table (a record in it), it will get you the next record, if you're calling it directly on the module it will treat the argument as key to start from and return you the next key.","ref":"Markov.Database.Link.html#next/1","title":"Markov.Database.Link.next/1","type":"function"},{"doc":"The options passed when the table was defined.","ref":"Markov.Database.Link.html#options/0","title":"Markov.Database.Link.options/0","type":"function"},{"doc":"Check if the table is an ordered set.","ref":"Markov.Database.Link.html#ordered_set?/0","title":"Markov.Database.Link.ordered_set?/0","type":"function"},{"doc":"Return the previous key or record in the table, see mnesia:dirty_prev . If you're calling this function from an instance of the table (a record in it), it will get you the previous record, if you're calling it directly on the module it will treat the argument as key to start from and return you the previous key.","ref":"Markov.Database.Link.html#prev!/1","title":"Markov.Database.Link.prev!/1","type":"function"},{"doc":"Return the previous key or record in the table, see mnesia:prev . If you're calling this function from an instance of the table (a record in it), it will get you the previous record, if you're calling it directly on the module it will treat the argument as key to start from and return you the previous key.","ref":"Markov.Database.Link.html#prev/1","title":"Markov.Database.Link.prev/1","type":"function"},{"doc":"Change the table loading priority.","ref":"Markov.Database.Link.html#priority/1","title":"Markov.Database.Link.priority/1","type":"function"},{"doc":"Return properties of the table.","ref":"Markov.Database.Link.html#properties/0","title":"Markov.Database.Link.properties/0","type":"function"},{"doc":"Read records from the table, see mnesia:dirty_read .","ref":"Markov.Database.Link.html#read!/1","title":"Markov.Database.Link.read!/1","type":"function"},{"doc":"Read records from the table with the given key and given lock, see mnesia:read . Locks :write sets a :write lock :write! sets a :sticky_write lock :read sets a :read lock","ref":"Markov.Database.Link.html#read/2","title":"Markov.Database.Link.read/2","type":"function"},{"doc":"Read records from the table based on a secondary index given as position, see mnesia:dirty_index_read .","ref":"Markov.Database.Link.html#read_at!/2","title":"Markov.Database.Link.read_at!/2","type":"function"},{"doc":"Read records from the table based on a secondary index given as position, see mnesia:index_read .","ref":"Markov.Database.Link.html#read_at/2","title":"Markov.Database.Link.read_at/2","type":"function"},{"doc":"Select records in the table using a match_spec, see mnesia:dirty_select .","ref":"Markov.Database.Link.html#select!/1","title":"Markov.Database.Link.select!/1","type":"function"},{"doc":"Select records in the table using a match_spec, see mnesia:select .","ref":"Markov.Database.Link.html#select/1","title":"Markov.Database.Link.select/1","type":"function"},{"doc":"Select records in the given table using a match_spec passing a limit or a lock kind, see mnesia:select .","ref":"Markov.Database.Link.html#select/2","title":"Markov.Database.Link.select/2","type":"function"},{"doc":"Select records in the given table using a match_spec passing a limit and a lock kind, see mnesia:select .","ref":"Markov.Database.Link.html#select/3","title":"Markov.Database.Link.select/3","type":"function"},{"doc":"Check if the table is a set.","ref":"Markov.Database.Link.html#set?/0","title":"Markov.Database.Link.set?/0","type":"function"},{"doc":"Return an iterator to use with the Enum functions using dirty operations to retrieve information.","ref":"Markov.Database.Link.html#stream!/0","title":"Markov.Database.Link.stream!/0","type":"function"},{"doc":"Return an iterator to use with Enum functions.","ref":"Markov.Database.Link.html#stream/1","title":"Markov.Database.Link.stream/1","type":"function"},{"doc":"Return the type of the table.","ref":"Markov.Database.Link.html#type/1","title":"Markov.Database.Link.type/1","type":"function"},{"doc":"Wait for the table optionally with a timeout.","ref":"Markov.Database.Link.html#wait/1","title":"Markov.Database.Link.wait/1","type":"function"},{"doc":"Select records in the table using an Exquisite query, see Exquisite.match/2 and mnesia:dirty_select . Options select - Exquisite selector spec qualified - whether to set a name for the record or not","ref":"Markov.Database.Link.html#where!/2","title":"Markov.Database.Link.where!/2","type":"macro"},{"doc":"Select records in the table using an Exquisite query, see Exquisite.match/2 and mnesia:select . Options limit - sets the count of elements to select in every continuation lock - sets the kind of lock to use select - Exquisite selector spec qualified - whether to set a name for the record or not","ref":"Markov.Database.Link.html#where/2","title":"Markov.Database.Link.where/2","type":"macro"},{"doc":"Write the record to the table, see mnesia:dirty_write . Missing fields tagged as autoincrement will be incremented with the counter if nil .","ref":"Markov.Database.Link.html#write!/1","title":"Markov.Database.Link.write!/1","type":"function"},{"doc":"Write the record to the table, see mnesia:write . Missing fields tagged as autoincrement will be incremented with the counter if nil .","ref":"Markov.Database.Link.html#write/2","title":"Markov.Database.Link.write/2","type":"function"},{"doc":"","ref":"Markov.Database.Link.html#t:autoincrement/0","title":"Markov.Database.Link.autoincrement/0","type":"type"},{"doc":"","ref":"Markov.Database.Link.html#t:t/0","title":"Markov.Database.Link.t/0","type":"type"},{"doc":"","ref":"Markov.Database.Master.html","title":"Markov.Database.Master","type":"module"},{"doc":"Require the needed modules to use the table effectively.","ref":"Markov.Database.Master.html#__using__/1","title":"Markov.Database.Master.__using__/1","type":"macro"},{"doc":"Add a copy of the table on the given node with the given mode.","ref":"Markov.Database.Master.html#add_copy/2","title":"Markov.Database.Master.add_copy/2","type":"function"},{"doc":"Add the index in the table for the given attribute.","ref":"Markov.Database.Master.html#add_index/1","title":"Markov.Database.Master.add_index/1","type":"function"},{"doc":"Read a record based on a slot, see mnesia:dirty_slot .","ref":"Markov.Database.Master.html#at!/1","title":"Markov.Database.Master.at!/1","type":"function"},{"doc":"The in order keyword list of attributes passed when the table was defined.","ref":"Markov.Database.Master.html#attributes/0","title":"Markov.Database.Master.attributes/0","type":"function"},{"doc":"Check if the table is a bag.","ref":"Markov.Database.Master.html#bag?/0","title":"Markov.Database.Master.bag?/0","type":"function"},{"doc":"Clear the content of the table.","ref":"Markov.Database.Master.html#clear/0","title":"Markov.Database.Master.clear/0","type":"function"},{"doc":"Change the copying mode of the table on the given node, see mnesia:change_table_copy_type . Modes :disk sets :disc_copies mode :disk! sets :disc_only_copies mode :memory sets :ram_copies mode","ref":"Markov.Database.Master.html#copying/2","title":"Markov.Database.Master.copying/2","type":"function"},{"doc":"Get the number of records in the table.","ref":"Markov.Database.Master.html#count/0","title":"Markov.Database.Master.count/0","type":"function"},{"doc":"","ref":"Markov.Database.Master.html#create!/1","title":"Markov.Database.Master.create!/1","type":"function"},{"doc":"Create the table with the given copying mode and inherent definition.","ref":"Markov.Database.Master.html#create/1","title":"Markov.Database.Master.create/1","type":"function"},{"doc":"Return the database the table belongs to.","ref":"Markov.Database.Master.html#database/0","title":"Markov.Database.Master.database/0","type":"function"},{"doc":"Delete the record or the given key from the table, see mnesia:dirty_delete and mnesia:dirty_delete_object .","ref":"Markov.Database.Master.html#delete!/1","title":"Markov.Database.Master.delete!/1","type":"function"},{"doc":"Delete the record or the given key from the table, see mnesia:delete and mnesia:delete_object .","ref":"Markov.Database.Master.html#delete/1","title":"Markov.Database.Master.delete/1","type":"function"},{"doc":"Delete the record or the given key from the table with the given lock, see mnesia:delete and mnesia:delete_object . Locks :write sets a :write lock :write! sets a :sticky_write lock","ref":"Markov.Database.Master.html#delete/2","title":"Markov.Database.Master.delete/2","type":"function"},{"doc":"Delete a copy of the table from the given node.","ref":"Markov.Database.Master.html#delete_copy/1","title":"Markov.Database.Master.delete_copy/1","type":"function"},{"doc":"Delete the index in the table for the given attribute.","ref":"Markov.Database.Master.html#delete_index/1","title":"Markov.Database.Master.delete_index/1","type":"function"},{"doc":"Destroy the table, raising if an error occurs.","ref":"Markov.Database.Master.html#destroy!/0","title":"Markov.Database.Master.destroy!/0","type":"function"},{"doc":"Destroy the table.","ref":"Markov.Database.Master.html#destroy/0","title":"Markov.Database.Master.destroy/0","type":"function"},{"doc":"Return the first key or record in the table, see mnesia:dirty_first . By default it returns the record, if you want only the key pass true as first parameter. If the table is a bag, it will return a list of records.","ref":"Markov.Database.Master.html#first!/1","title":"Markov.Database.Master.first!/1","type":"function"},{"doc":"Return the first key or record in the table, see mnesia:first . By default it returns the record, if you want only the key pass true as first parameter. If the table is a bag, it will return a list of records.","ref":"Markov.Database.Master.html#first/2","title":"Markov.Database.Master.first/2","type":"function"},{"doc":"Fold the whole table from the left, see mnesia:foldl .","ref":"Markov.Database.Master.html#foldl/2","title":"Markov.Database.Master.foldl/2","type":"function"},{"doc":"Fold the whole table from the right, see mnesia:foldr .","ref":"Markov.Database.Master.html#foldr/2","title":"Markov.Database.Master.foldr/2","type":"function"},{"doc":"Force load the table.","ref":"Markov.Database.Master.html#force/0","title":"Markov.Database.Master.force/0","type":"function"},{"doc":"","ref":"Markov.Database.Master.html#hook_read!/2","title":"Markov.Database.Master.hook_read!/2","type":"function"},{"doc":"","ref":"Markov.Database.Master.html#hook_read/2","title":"Markov.Database.Master.hook_read/2","type":"function"},{"doc":"","ref":"Markov.Database.Master.html#hook_write!/1","title":"Markov.Database.Master.hook_write!/1","type":"function"},{"doc":"","ref":"Markov.Database.Master.html#hook_write/1","title":"Markov.Database.Master.hook_write/1","type":"function"},{"doc":"Get the name of the id key.","ref":"Markov.Database.Master.html#id/0","title":"Markov.Database.Master.id/0","type":"function"},{"doc":"Get information about the table, see mnesia:table_info .","ref":"Markov.Database.Master.html#info/1","title":"Markov.Database.Master.info/1","type":"function"},{"doc":"Return the key of the record.","ref":"Markov.Database.Master.html#key/1","title":"Markov.Database.Master.key/1","type":"function"},{"doc":"Return all keys in the table, see mnesia:dirty_all_keys .","ref":"Markov.Database.Master.html#keys!/0","title":"Markov.Database.Master.keys!/0","type":"function"},{"doc":"Return all the keys in the table, see mnesia:all_keys .","ref":"Markov.Database.Master.html#keys/0","title":"Markov.Database.Master.keys/0","type":"function"},{"doc":"Return the last key or record in the table, see mnesia:dirty_last . By default it returns the record, if you want only the key pass true as first parameter. If the table is a bag, it will return a list of records.","ref":"Markov.Database.Master.html#last!/1","title":"Markov.Database.Master.last!/1","type":"function"},{"doc":"Return the last key or record in the table, see mnesia:last . By default it returns the record, if you want only the key pass true as first parameter. If the table is a bag, it will return a list of records.","ref":"Markov.Database.Master.html#last/2","title":"Markov.Database.Master.last/2","type":"function"},{"doc":"Lock the table with the given lock. Locks :write sets a :write lock :write! sets a :sticky_write lock :read sets a :read lock","ref":"Markov.Database.Master.html#lock/1","title":"Markov.Database.Master.lock/1","type":"function"},{"doc":"Change the table majority.","ref":"Markov.Database.Master.html#majority/1","title":"Markov.Database.Master.majority/1","type":"function"},{"doc":"Set master nodes for the table, see mnesia:set_master_nodes .","ref":"Markov.Database.Master.html#master_nodes/1","title":"Markov.Database.Master.master_nodes/1","type":"function"},{"doc":"Select records in the table using simple don't care values, see mnesia:dirty_match_object .","ref":"Markov.Database.Master.html#match!/1","title":"Markov.Database.Master.match!/1","type":"function"},{"doc":"Select records in the table using simple don't care values, see mnesia:match_object .","ref":"Markov.Database.Master.html#match/2","title":"Markov.Database.Master.match/2","type":"function"},{"doc":"Check if the key is present in the table.","ref":"Markov.Database.Master.html#member?/1","title":"Markov.Database.Master.member?/1","type":"function"},{"doc":"Change the access of the table, see mnesia:change_table_access_mode . Modes :both sets read and write mode, it's the default. :read! sets read-only mode.","ref":"Markov.Database.Master.html#mode/1","title":"Markov.Database.Master.mode/1","type":"function"},{"doc":"Move a copy of the table from the given node to another given node.","ref":"Markov.Database.Master.html#move_copy/2","title":"Markov.Database.Master.move_copy/2","type":"function"},{"doc":"Return the next key or record in the table, see mnesia:dirty_next . If you're calling this function from an instance of the table (a record in it), it will get you the next record, if you're calling it directly on the module it will treat the argument as key to start from and return you the next key.","ref":"Markov.Database.Master.html#next!/1","title":"Markov.Database.Master.next!/1","type":"function"},{"doc":"Return the next key or record in the table, see mnesia:next . If you're calling this function from an instance of the table (a record in it), it will get you the next record, if you're calling it directly on the module it will treat the argument as key to start from and return you the next key.","ref":"Markov.Database.Master.html#next/1","title":"Markov.Database.Master.next/1","type":"function"},{"doc":"The options passed when the table was defined.","ref":"Markov.Database.Master.html#options/0","title":"Markov.Database.Master.options/0","type":"function"},{"doc":"Check if the table is an ordered set.","ref":"Markov.Database.Master.html#ordered_set?/0","title":"Markov.Database.Master.ordered_set?/0","type":"function"},{"doc":"Return the previous key or record in the table, see mnesia:dirty_prev . If you're calling this function from an instance of the table (a record in it), it will get you the previous record, if you're calling it directly on the module it will treat the argument as key to start from and return you the previous key.","ref":"Markov.Database.Master.html#prev!/1","title":"Markov.Database.Master.prev!/1","type":"function"},{"doc":"Return the previous key or record in the table, see mnesia:prev . If you're calling this function from an instance of the table (a record in it), it will get you the previous record, if you're calling it directly on the module it will treat the argument as key to start from and return you the previous key.","ref":"Markov.Database.Master.html#prev/1","title":"Markov.Database.Master.prev/1","type":"function"},{"doc":"Change the table loading priority.","ref":"Markov.Database.Master.html#priority/1","title":"Markov.Database.Master.priority/1","type":"function"},{"doc":"Return properties of the table.","ref":"Markov.Database.Master.html#properties/0","title":"Markov.Database.Master.properties/0","type":"function"},{"doc":"Read a record from the table, see mnesia:dirty_read . Unlike mnesia:dirty_read this returns either the record or nil.","ref":"Markov.Database.Master.html#read!/1","title":"Markov.Database.Master.read!/1","type":"function"},{"doc":"Read a record from the table with the given lock, see mnesia:read . Unlike mnesia:read this returns either the record or nil. Locks :write sets a :write lock :write! sets a :sticky_write lock :read sets a :read lock","ref":"Markov.Database.Master.html#read/2","title":"Markov.Database.Master.read/2","type":"function"},{"doc":"Read records from the table based on a secondary index given as position, see mnesia:dirty_index_read .","ref":"Markov.Database.Master.html#read_at!/2","title":"Markov.Database.Master.read_at!/2","type":"function"},{"doc":"Read records from the table based on a secondary index given as position, see mnesia:index_read .","ref":"Markov.Database.Master.html#read_at/2","title":"Markov.Database.Master.read_at/2","type":"function"},{"doc":"Select records in the table using a match_spec, see mnesia:dirty_select .","ref":"Markov.Database.Master.html#select!/1","title":"Markov.Database.Master.select!/1","type":"function"},{"doc":"Select records in the table using a match_spec, see mnesia:select .","ref":"Markov.Database.Master.html#select/1","title":"Markov.Database.Master.select/1","type":"function"},{"doc":"Select records in the given table using a match_spec passing a limit or a lock kind, see mnesia:select .","ref":"Markov.Database.Master.html#select/2","title":"Markov.Database.Master.select/2","type":"function"},{"doc":"Select records in the given table using a match_spec passing a limit and a lock kind, see mnesia:select .","ref":"Markov.Database.Master.html#select/3","title":"Markov.Database.Master.select/3","type":"function"},{"doc":"Check if the table is a set.","ref":"Markov.Database.Master.html#set?/0","title":"Markov.Database.Master.set?/0","type":"function"},{"doc":"Return an iterator to use with the Enum functions using dirty operations to retrieve information.","ref":"Markov.Database.Master.html#stream!/0","title":"Markov.Database.Master.stream!/0","type":"function"},{"doc":"Return an iterator to use with Enum functions.","ref":"Markov.Database.Master.html#stream/1","title":"Markov.Database.Master.stream/1","type":"function"},{"doc":"Return the type of the table.","ref":"Markov.Database.Master.html#type/1","title":"Markov.Database.Master.type/1","type":"function"},{"doc":"Wait for the table optionally with a timeout.","ref":"Markov.Database.Master.html#wait/1","title":"Markov.Database.Master.wait/1","type":"function"},{"doc":"Select records in the table using an Exquisite query, see Exquisite.match/2 and mnesia:dirty_select . Options select - Exquisite selector spec qualified - whether to set a name for the record or not","ref":"Markov.Database.Master.html#where!/2","title":"Markov.Database.Master.where!/2","type":"macro"},{"doc":"Select records in the table using an Exquisite query, see Exquisite.match/2 and mnesia:select . Options limit - sets the count of elements to select in every continuation lock - sets the kind of lock to use select - Exquisite selector spec qualified - whether to set a name for the record or not","ref":"Markov.Database.Master.html#where/2","title":"Markov.Database.Master.where/2","type":"macro"},{"doc":"Write the record to the table, see mnesia:dirty_write . Missing fields tagged as autoincrement will be incremented with the counter if nil .","ref":"Markov.Database.Master.html#write!/1","title":"Markov.Database.Master.write!/1","type":"function"},{"doc":"Write the record to the table, see mnesia:write . Missing fields tagged as autoincrement will be incremented with the counter if nil .","ref":"Markov.Database.Master.html#write/2","title":"Markov.Database.Master.write/2","type":"function"},{"doc":"","ref":"Markov.Database.Master.html#t:autoincrement/0","title":"Markov.Database.Master.autoincrement/0","type":"type"},{"doc":"","ref":"Markov.Database.Master.html#t:t/0","title":"Markov.Database.Master.t/0","type":"type"},{"doc":"","ref":"Markov.Database.Operation.html","title":"Markov.Database.Operation","type":"module"},{"doc":"Require the needed modules to use the table effectively.","ref":"Markov.Database.Operation.html#__using__/1","title":"Markov.Database.Operation.__using__/1","type":"macro"},{"doc":"Add a copy of the table on the given node with the given mode.","ref":"Markov.Database.Operation.html#add_copy/2","title":"Markov.Database.Operation.add_copy/2","type":"function"},{"doc":"Add the index in the table for the given attribute.","ref":"Markov.Database.Operation.html#add_index/1","title":"Markov.Database.Operation.add_index/1","type":"function"},{"doc":"Read a record based on a slot, see mnesia:dirty_slot .","ref":"Markov.Database.Operation.html#at!/1","title":"Markov.Database.Operation.at!/1","type":"function"},{"doc":"The in order keyword list of attributes passed when the table was defined.","ref":"Markov.Database.Operation.html#attributes/0","title":"Markov.Database.Operation.attributes/0","type":"function"},{"doc":"Check if the table is a bag.","ref":"Markov.Database.Operation.html#bag?/0","title":"Markov.Database.Operation.bag?/0","type":"function"},{"doc":"Clear the content of the table.","ref":"Markov.Database.Operation.html#clear/0","title":"Markov.Database.Operation.clear/0","type":"function"},{"doc":"Change the copying mode of the table on the given node, see mnesia:change_table_copy_type . Modes :disk sets :disc_copies mode :disk! sets :disc_only_copies mode :memory sets :ram_copies mode","ref":"Markov.Database.Operation.html#copying/2","title":"Markov.Database.Operation.copying/2","type":"function"},{"doc":"Get the number of records in the table.","ref":"Markov.Database.Operation.html#count/0","title":"Markov.Database.Operation.count/0","type":"function"},{"doc":"","ref":"Markov.Database.Operation.html#create!/1","title":"Markov.Database.Operation.create!/1","type":"function"},{"doc":"Create the table with the given copying mode and inherent definition.","ref":"Markov.Database.Operation.html#create/1","title":"Markov.Database.Operation.create/1","type":"function"},{"doc":"Return the database the table belongs to.","ref":"Markov.Database.Operation.html#database/0","title":"Markov.Database.Operation.database/0","type":"function"},{"doc":"Delete the record or the given key from the table, see mnesia:dirty_delete and mnesia:dirty_delete_object .","ref":"Markov.Database.Operation.html#delete!/1","title":"Markov.Database.Operation.delete!/1","type":"function"},{"doc":"Delete the record or the given key from the table, see mnesia:delete and mnesia:delete_object .","ref":"Markov.Database.Operation.html#delete/1","title":"Markov.Database.Operation.delete/1","type":"function"},{"doc":"Delete the record or the given key from the table with the given lock, see mnesia:delete and mnesia:delete_object . Locks :write sets a :write lock :write! sets a :sticky_write lock","ref":"Markov.Database.Operation.html#delete/2","title":"Markov.Database.Operation.delete/2","type":"function"},{"doc":"Delete a copy of the table from the given node.","ref":"Markov.Database.Operation.html#delete_copy/1","title":"Markov.Database.Operation.delete_copy/1","type":"function"},{"doc":"Delete the index in the table for the given attribute.","ref":"Markov.Database.Operation.html#delete_index/1","title":"Markov.Database.Operation.delete_index/1","type":"function"},{"doc":"Destroy the table, raising if an error occurs.","ref":"Markov.Database.Operation.html#destroy!/0","title":"Markov.Database.Operation.destroy!/0","type":"function"},{"doc":"Destroy the table.","ref":"Markov.Database.Operation.html#destroy/0","title":"Markov.Database.Operation.destroy/0","type":"function"},{"doc":"Return the first key or record in the table, see mnesia:dirty_first . By default it returns the record, if you want only the key pass true as first parameter. If the table is a bag, it will return a list of records.","ref":"Markov.Database.Operation.html#first!/1","title":"Markov.Database.Operation.first!/1","type":"function"},{"doc":"Return the first key or record in the table, see mnesia:first . By default it returns the record, if you want only the key pass true as first parameter. If the table is a bag, it will return a list of records.","ref":"Markov.Database.Operation.html#first/2","title":"Markov.Database.Operation.first/2","type":"function"},{"doc":"Fold the whole table from the left, see mnesia:foldl .","ref":"Markov.Database.Operation.html#foldl/2","title":"Markov.Database.Operation.foldl/2","type":"function"},{"doc":"Fold the whole table from the right, see mnesia:foldr .","ref":"Markov.Database.Operation.html#foldr/2","title":"Markov.Database.Operation.foldr/2","type":"function"},{"doc":"Force load the table.","ref":"Markov.Database.Operation.html#force/0","title":"Markov.Database.Operation.force/0","type":"function"},{"doc":"","ref":"Markov.Database.Operation.html#hook_read!/2","title":"Markov.Database.Operation.hook_read!/2","type":"function"},{"doc":"","ref":"Markov.Database.Operation.html#hook_read/2","title":"Markov.Database.Operation.hook_read/2","type":"function"},{"doc":"","ref":"Markov.Database.Operation.html#hook_write!/1","title":"Markov.Database.Operation.hook_write!/1","type":"function"},{"doc":"","ref":"Markov.Database.Operation.html#hook_write/1","title":"Markov.Database.Operation.hook_write/1","type":"function"},{"doc":"Get the name of the id key.","ref":"Markov.Database.Operation.html#id/0","title":"Markov.Database.Operation.id/0","type":"function"},{"doc":"Get information about the table, see mnesia:table_info .","ref":"Markov.Database.Operation.html#info/1","title":"Markov.Database.Operation.info/1","type":"function"},{"doc":"Return the key of the record.","ref":"Markov.Database.Operation.html#key/1","title":"Markov.Database.Operation.key/1","type":"function"},{"doc":"Return all keys in the table, see mnesia:dirty_all_keys .","ref":"Markov.Database.Operation.html#keys!/0","title":"Markov.Database.Operation.keys!/0","type":"function"},{"doc":"Return all the keys in the table, see mnesia:all_keys .","ref":"Markov.Database.Operation.html#keys/0","title":"Markov.Database.Operation.keys/0","type":"function"},{"doc":"Return the last key or record in the table, see mnesia:dirty_last . By default it returns the record, if you want only the key pass true as first parameter. If the table is a bag, it will return a list of records.","ref":"Markov.Database.Operation.html#last!/1","title":"Markov.Database.Operation.last!/1","type":"function"},{"doc":"Return the last key or record in the table, see mnesia:last . By default it returns the record, if you want only the key pass true as first parameter. If the table is a bag, it will return a list of records.","ref":"Markov.Database.Operation.html#last/2","title":"Markov.Database.Operation.last/2","type":"function"},{"doc":"Lock the table with the given lock. Locks :write sets a :write lock :write! sets a :sticky_write lock :read sets a :read lock","ref":"Markov.Database.Operation.html#lock/1","title":"Markov.Database.Operation.lock/1","type":"function"},{"doc":"Change the table majority.","ref":"Markov.Database.Operation.html#majority/1","title":"Markov.Database.Operation.majority/1","type":"function"},{"doc":"Set master nodes for the table, see mnesia:set_master_nodes .","ref":"Markov.Database.Operation.html#master_nodes/1","title":"Markov.Database.Operation.master_nodes/1","type":"function"},{"doc":"Select records in the table using simple don't care values, see mnesia:dirty_match_object .","ref":"Markov.Database.Operation.html#match!/1","title":"Markov.Database.Operation.match!/1","type":"function"},{"doc":"Select records in the table using simple don't care values, see mnesia:match_object .","ref":"Markov.Database.Operation.html#match/2","title":"Markov.Database.Operation.match/2","type":"function"},{"doc":"Check if the key is present in the table.","ref":"Markov.Database.Operation.html#member?/1","title":"Markov.Database.Operation.member?/1","type":"function"},{"doc":"Change the access of the table, see mnesia:change_table_access_mode . Modes :both sets read and write mode, it's the default. :read! sets read-only mode.","ref":"Markov.Database.Operation.html#mode/1","title":"Markov.Database.Operation.mode/1","type":"function"},{"doc":"Move a copy of the table from the given node to another given node.","ref":"Markov.Database.Operation.html#move_copy/2","title":"Markov.Database.Operation.move_copy/2","type":"function"},{"doc":"Return the next key or record in the table, see mnesia:dirty_next . If you're calling this function from an instance of the table (a record in it), it will get you the next record, if you're calling it directly on the module it will treat the argument as key to start from and return you the next key.","ref":"Markov.Database.Operation.html#next!/1","title":"Markov.Database.Operation.next!/1","type":"function"},{"doc":"Return the next key or record in the table, see mnesia:next . If you're calling this function from an instance of the table (a record in it), it will get you the next record, if you're calling it directly on the module it will treat the argument as key to start from and return you the next key.","ref":"Markov.Database.Operation.html#next/1","title":"Markov.Database.Operation.next/1","type":"function"},{"doc":"The options passed when the table was defined.","ref":"Markov.Database.Operation.html#options/0","title":"Markov.Database.Operation.options/0","type":"function"},{"doc":"Check if the table is an ordered set.","ref":"Markov.Database.Operation.html#ordered_set?/0","title":"Markov.Database.Operation.ordered_set?/0","type":"function"},{"doc":"Return the previous key or record in the table, see mnesia:dirty_prev . If you're calling this function from an instance of the table (a record in it), it will get you the previous record, if you're calling it directly on the module it will treat the argument as key to start from and return you the previous key.","ref":"Markov.Database.Operation.html#prev!/1","title":"Markov.Database.Operation.prev!/1","type":"function"},{"doc":"Return the previous key or record in the table, see mnesia:prev . If you're calling this function from an instance of the table (a record in it), it will get you the previous record, if you're calling it directly on the module it will treat the argument as key to start from and return you the previous key.","ref":"Markov.Database.Operation.html#prev/1","title":"Markov.Database.Operation.prev/1","type":"function"},{"doc":"Change the table loading priority.","ref":"Markov.Database.Operation.html#priority/1","title":"Markov.Database.Operation.priority/1","type":"function"},{"doc":"Return properties of the table.","ref":"Markov.Database.Operation.html#properties/0","title":"Markov.Database.Operation.properties/0","type":"function"},{"doc":"Read records from the table, see mnesia:dirty_read .","ref":"Markov.Database.Operation.html#read!/1","title":"Markov.Database.Operation.read!/1","type":"function"},{"doc":"Read records from the table with the given key and given lock, see mnesia:read . Locks :write sets a :write lock :write! sets a :sticky_write lock :read sets a :read lock","ref":"Markov.Database.Operation.html#read/2","title":"Markov.Database.Operation.read/2","type":"function"},{"doc":"Read records from the table based on a secondary index given as position, see mnesia:dirty_index_read .","ref":"Markov.Database.Operation.html#read_at!/2","title":"Markov.Database.Operation.read_at!/2","type":"function"},{"doc":"Read records from the table based on a secondary index given as position, see mnesia:index_read .","ref":"Markov.Database.Operation.html#read_at/2","title":"Markov.Database.Operation.read_at/2","type":"function"},{"doc":"Select records in the table using a match_spec, see mnesia:dirty_select .","ref":"Markov.Database.Operation.html#select!/1","title":"Markov.Database.Operation.select!/1","type":"function"},{"doc":"Select records in the table using a match_spec, see mnesia:select .","ref":"Markov.Database.Operation.html#select/1","title":"Markov.Database.Operation.select/1","type":"function"},{"doc":"Select records in the given table using a match_spec passing a limit or a lock kind, see mnesia:select .","ref":"Markov.Database.Operation.html#select/2","title":"Markov.Database.Operation.select/2","type":"function"},{"doc":"Select records in the given table using a match_spec passing a limit and a lock kind, see mnesia:select .","ref":"Markov.Database.Operation.html#select/3","title":"Markov.Database.Operation.select/3","type":"function"},{"doc":"Check if the table is a set.","ref":"Markov.Database.Operation.html#set?/0","title":"Markov.Database.Operation.set?/0","type":"function"},{"doc":"Return an iterator to use with the Enum functions using dirty operations to retrieve information.","ref":"Markov.Database.Operation.html#stream!/0","title":"Markov.Database.Operation.stream!/0","type":"function"},{"doc":"Return an iterator to use with Enum functions.","ref":"Markov.Database.Operation.html#stream/1","title":"Markov.Database.Operation.stream/1","type":"function"},{"doc":"Return the type of the table.","ref":"Markov.Database.Operation.html#type/1","title":"Markov.Database.Operation.type/1","type":"function"},{"doc":"Wait for the table optionally with a timeout.","ref":"Markov.Database.Operation.html#wait/1","title":"Markov.Database.Operation.wait/1","type":"function"},{"doc":"Select records in the table using an Exquisite query, see Exquisite.match/2 and mnesia:dirty_select . Options select - Exquisite selector spec qualified - whether to set a name for the record or not","ref":"Markov.Database.Operation.html#where!/2","title":"Markov.Database.Operation.where!/2","type":"macro"},{"doc":"Select records in the table using an Exquisite query, see Exquisite.match/2 and mnesia:select . Options limit - sets the count of elements to select in every continuation lock - sets the kind of lock to use select - Exquisite selector spec qualified - whether to set a name for the record or not","ref":"Markov.Database.Operation.html#where/2","title":"Markov.Database.Operation.where/2","type":"macro"},{"doc":"Write the record to the table, see mnesia:dirty_write . Missing fields tagged as autoincrement will be incremented with the counter if nil .","ref":"Markov.Database.Operation.html#write!/1","title":"Markov.Database.Operation.write!/1","type":"function"},{"doc":"Write the record to the table, see mnesia:write . Missing fields tagged as autoincrement will be incremented with the counter if nil .","ref":"Markov.Database.Operation.html#write/2","title":"Markov.Database.Operation.write/2","type":"function"},{"doc":"","ref":"Markov.Database.Operation.html#t:autoincrement/0","title":"Markov.Database.Operation.autoincrement/0","type":"type"},{"doc":"","ref":"Markov.Database.Operation.html#t:t/0","title":"Markov.Database.Operation.t/0","type":"type"},{"doc":"","ref":"Markov.Database.Weight.html","title":"Markov.Database.Weight","type":"module"},{"doc":"Require the needed modules to use the table effectively.","ref":"Markov.Database.Weight.html#__using__/1","title":"Markov.Database.Weight.__using__/1","type":"macro"},{"doc":"Add a copy of the table on the given node with the given mode.","ref":"Markov.Database.Weight.html#add_copy/2","title":"Markov.Database.Weight.add_copy/2","type":"function"},{"doc":"Add the index in the table for the given attribute.","ref":"Markov.Database.Weight.html#add_index/1","title":"Markov.Database.Weight.add_index/1","type":"function"},{"doc":"Read a record based on a slot, see mnesia:dirty_slot .","ref":"Markov.Database.Weight.html#at!/1","title":"Markov.Database.Weight.at!/1","type":"function"},{"doc":"The in order keyword list of attributes passed when the table was defined.","ref":"Markov.Database.Weight.html#attributes/0","title":"Markov.Database.Weight.attributes/0","type":"function"},{"doc":"Check if the table is a bag.","ref":"Markov.Database.Weight.html#bag?/0","title":"Markov.Database.Weight.bag?/0","type":"function"},{"doc":"Clear the content of the table.","ref":"Markov.Database.Weight.html#clear/0","title":"Markov.Database.Weight.clear/0","type":"function"},{"doc":"Change the copying mode of the table on the given node, see mnesia:change_table_copy_type . Modes :disk sets :disc_copies mode :disk! sets :disc_only_copies mode :memory sets :ram_copies mode","ref":"Markov.Database.Weight.html#copying/2","title":"Markov.Database.Weight.copying/2","type":"function"},{"doc":"Get the number of records in the table.","ref":"Markov.Database.Weight.html#count/0","title":"Markov.Database.Weight.count/0","type":"function"},{"doc":"","ref":"Markov.Database.Weight.html#create!/1","title":"Markov.Database.Weight.create!/1","type":"function"},{"doc":"Create the table with the given copying mode and inherent definition.","ref":"Markov.Database.Weight.html#create/1","title":"Markov.Database.Weight.create/1","type":"function"},{"doc":"Return the database the table belongs to.","ref":"Markov.Database.Weight.html#database/0","title":"Markov.Database.Weight.database/0","type":"function"},{"doc":"Delete the record or the given key from the table, see mnesia:dirty_delete and mnesia:dirty_delete_object .","ref":"Markov.Database.Weight.html#delete!/1","title":"Markov.Database.Weight.delete!/1","type":"function"},{"doc":"Delete the record or the given key from the table, see mnesia:delete and mnesia:delete_object .","ref":"Markov.Database.Weight.html#delete/1","title":"Markov.Database.Weight.delete/1","type":"function"},{"doc":"Delete the record or the given key from the table with the given lock, see mnesia:delete and mnesia:delete_object . Locks :write sets a :write lock :write! sets a :sticky_write lock","ref":"Markov.Database.Weight.html#delete/2","title":"Markov.Database.Weight.delete/2","type":"function"},{"doc":"Delete a copy of the table from the given node.","ref":"Markov.Database.Weight.html#delete_copy/1","title":"Markov.Database.Weight.delete_copy/1","type":"function"},{"doc":"Delete the index in the table for the given attribute.","ref":"Markov.Database.Weight.html#delete_index/1","title":"Markov.Database.Weight.delete_index/1","type":"function"},{"doc":"Destroy the table, raising if an error occurs.","ref":"Markov.Database.Weight.html#destroy!/0","title":"Markov.Database.Weight.destroy!/0","type":"function"},{"doc":"Destroy the table.","ref":"Markov.Database.Weight.html#destroy/0","title":"Markov.Database.Weight.destroy/0","type":"function"},{"doc":"Return the first key or record in the table, see mnesia:dirty_first . By default it returns the record, if you want only the key pass true as first parameter. If the table is a bag, it will return a list of records.","ref":"Markov.Database.Weight.html#first!/1","title":"Markov.Database.Weight.first!/1","type":"function"},{"doc":"Return the first key or record in the table, see mnesia:first . By default it returns the record, if you want only the key pass true as first parameter. If the table is a bag, it will return a list of records.","ref":"Markov.Database.Weight.html#first/2","title":"Markov.Database.Weight.first/2","type":"function"},{"doc":"Fold the whole table from the left, see mnesia:foldl .","ref":"Markov.Database.Weight.html#foldl/2","title":"Markov.Database.Weight.foldl/2","type":"function"},{"doc":"Fold the whole table from the right, see mnesia:foldr .","ref":"Markov.Database.Weight.html#foldr/2","title":"Markov.Database.Weight.foldr/2","type":"function"},{"doc":"Force load the table.","ref":"Markov.Database.Weight.html#force/0","title":"Markov.Database.Weight.force/0","type":"function"},{"doc":"","ref":"Markov.Database.Weight.html#hook_read!/2","title":"Markov.Database.Weight.hook_read!/2","type":"function"},{"doc":"","ref":"Markov.Database.Weight.html#hook_read/2","title":"Markov.Database.Weight.hook_read/2","type":"function"},{"doc":"","ref":"Markov.Database.Weight.html#hook_write!/1","title":"Markov.Database.Weight.hook_write!/1","type":"function"},{"doc":"","ref":"Markov.Database.Weight.html#hook_write/1","title":"Markov.Database.Weight.hook_write/1","type":"function"},{"doc":"Get the name of the id key.","ref":"Markov.Database.Weight.html#id/0","title":"Markov.Database.Weight.id/0","type":"function"},{"doc":"Get information about the table, see mnesia:table_info .","ref":"Markov.Database.Weight.html#info/1","title":"Markov.Database.Weight.info/1","type":"function"},{"doc":"Return the key of the record.","ref":"Markov.Database.Weight.html#key/1","title":"Markov.Database.Weight.key/1","type":"function"},{"doc":"Return all keys in the table, see mnesia:dirty_all_keys .","ref":"Markov.Database.Weight.html#keys!/0","title":"Markov.Database.Weight.keys!/0","type":"function"},{"doc":"Return all the keys in the table, see mnesia:all_keys .","ref":"Markov.Database.Weight.html#keys/0","title":"Markov.Database.Weight.keys/0","type":"function"},{"doc":"Return the last key or record in the table, see mnesia:dirty_last . By default it returns the record, if you want only the key pass true as first parameter. If the table is a bag, it will return a list of records.","ref":"Markov.Database.Weight.html#last!/1","title":"Markov.Database.Weight.last!/1","type":"function"},{"doc":"Return the last key or record in the table, see mnesia:last . By default it returns the record, if you want only the key pass true as first parameter. If the table is a bag, it will return a list of records.","ref":"Markov.Database.Weight.html#last/2","title":"Markov.Database.Weight.last/2","type":"function"},{"doc":"Lock the table with the given lock. Locks :write sets a :write lock :write! sets a :sticky_write lock :read sets a :read lock","ref":"Markov.Database.Weight.html#lock/1","title":"Markov.Database.Weight.lock/1","type":"function"},{"doc":"Change the table majority.","ref":"Markov.Database.Weight.html#majority/1","title":"Markov.Database.Weight.majority/1","type":"function"},{"doc":"Set master nodes for the table, see mnesia:set_master_nodes .","ref":"Markov.Database.Weight.html#master_nodes/1","title":"Markov.Database.Weight.master_nodes/1","type":"function"},{"doc":"Select records in the table using simple don't care values, see mnesia:dirty_match_object .","ref":"Markov.Database.Weight.html#match!/1","title":"Markov.Database.Weight.match!/1","type":"function"},{"doc":"Select records in the table using simple don't care values, see mnesia:match_object .","ref":"Markov.Database.Weight.html#match/2","title":"Markov.Database.Weight.match/2","type":"function"},{"doc":"Check if the key is present in the table.","ref":"Markov.Database.Weight.html#member?/1","title":"Markov.Database.Weight.member?/1","type":"function"},{"doc":"Change the access of the table, see mnesia:change_table_access_mode . Modes :both sets read and write mode, it's the default. :read! sets read-only mode.","ref":"Markov.Database.Weight.html#mode/1","title":"Markov.Database.Weight.mode/1","type":"function"},{"doc":"Move a copy of the table from the given node to another given node.","ref":"Markov.Database.Weight.html#move_copy/2","title":"Markov.Database.Weight.move_copy/2","type":"function"},{"doc":"Return the next key or record in the table, see mnesia:dirty_next . If you're calling this function from an instance of the table (a record in it), it will get you the next record, if you're calling it directly on the module it will treat the argument as key to start from and return you the next key.","ref":"Markov.Database.Weight.html#next!/1","title":"Markov.Database.Weight.next!/1","type":"function"},{"doc":"Return the next key or record in the table, see mnesia:next . If you're calling this function from an instance of the table (a record in it), it will get you the next record, if you're calling it directly on the module it will treat the argument as key to start from and return you the next key.","ref":"Markov.Database.Weight.html#next/1","title":"Markov.Database.Weight.next/1","type":"function"},{"doc":"The options passed when the table was defined.","ref":"Markov.Database.Weight.html#options/0","title":"Markov.Database.Weight.options/0","type":"function"},{"doc":"Check if the table is an ordered set.","ref":"Markov.Database.Weight.html#ordered_set?/0","title":"Markov.Database.Weight.ordered_set?/0","type":"function"},{"doc":"Return the previous key or record in the table, see mnesia:dirty_prev . If you're calling this function from an instance of the table (a record in it), it will get you the previous record, if you're calling it directly on the module it will treat the argument as key to start from and return you the previous key.","ref":"Markov.Database.Weight.html#prev!/1","title":"Markov.Database.Weight.prev!/1","type":"function"},{"doc":"Return the previous key or record in the table, see mnesia:prev . If you're calling this function from an instance of the table (a record in it), it will get you the previous record, if you're calling it directly on the module it will treat the argument as key to start from and return you the previous key.","ref":"Markov.Database.Weight.html#prev/1","title":"Markov.Database.Weight.prev/1","type":"function"},{"doc":"Change the table loading priority.","ref":"Markov.Database.Weight.html#priority/1","title":"Markov.Database.Weight.priority/1","type":"function"},{"doc":"Return properties of the table.","ref":"Markov.Database.Weight.html#properties/0","title":"Markov.Database.Weight.properties/0","type":"function"},{"doc":"Read a record from the table, see mnesia:dirty_read . Unlike mnesia:dirty_read this returns either the record or nil.","ref":"Markov.Database.Weight.html#read!/1","title":"Markov.Database.Weight.read!/1","type":"function"},{"doc":"Read a record from the table with the given lock, see mnesia:read . Unlike mnesia:read this returns either the record or nil. Locks :write sets a :write lock :write! sets a :sticky_write lock :read sets a :read lock","ref":"Markov.Database.Weight.html#read/2","title":"Markov.Database.Weight.read/2","type":"function"},{"doc":"Read records from the table based on a secondary index given as position, see mnesia:dirty_index_read .","ref":"Markov.Database.Weight.html#read_at!/2","title":"Markov.Database.Weight.read_at!/2","type":"function"},{"doc":"Read records from the table based on a secondary index given as position, see mnesia:index_read .","ref":"Markov.Database.Weight.html#read_at/2","title":"Markov.Database.Weight.read_at/2","type":"function"},{"doc":"Select records in the table using a match_spec, see mnesia:dirty_select .","ref":"Markov.Database.Weight.html#select!/1","title":"Markov.Database.Weight.select!/1","type":"function"},{"doc":"Select records in the table using a match_spec, see mnesia:select .","ref":"Markov.Database.Weight.html#select/1","title":"Markov.Database.Weight.select/1","type":"function"},{"doc":"Select records in the given table using a match_spec passing a limit or a lock kind, see mnesia:select .","ref":"Markov.Database.Weight.html#select/2","title":"Markov.Database.Weight.select/2","type":"function"},{"doc":"Select records in the given table using a match_spec passing a limit and a lock kind, see mnesia:select .","ref":"Markov.Database.Weight.html#select/3","title":"Markov.Database.Weight.select/3","type":"function"},{"doc":"Check if the table is a set.","ref":"Markov.Database.Weight.html#set?/0","title":"Markov.Database.Weight.set?/0","type":"function"},{"doc":"Return an iterator to use with the Enum functions using dirty operations to retrieve information.","ref":"Markov.Database.Weight.html#stream!/0","title":"Markov.Database.Weight.stream!/0","type":"function"},{"doc":"Return an iterator to use with Enum functions.","ref":"Markov.Database.Weight.html#stream/1","title":"Markov.Database.Weight.stream/1","type":"function"},{"doc":"Return the type of the table.","ref":"Markov.Database.Weight.html#type/1","title":"Markov.Database.Weight.type/1","type":"function"},{"doc":"Wait for the table optionally with a timeout.","ref":"Markov.Database.Weight.html#wait/1","title":"Markov.Database.Weight.wait/1","type":"function"},{"doc":"Select records in the table using an Exquisite query, see Exquisite.match/2 and mnesia:dirty_select . Options select - Exquisite selector spec qualified - whether to set a name for the record or not","ref":"Markov.Database.Weight.html#where!/2","title":"Markov.Database.Weight.where!/2","type":"macro"},{"doc":"Select records in the table using an Exquisite query, see Exquisite.match/2 and mnesia:select . Options limit - sets the count of elements to select in every continuation lock - sets the kind of lock to use select - Exquisite selector spec qualified - whether to set a name for the record or not","ref":"Markov.Database.Weight.html#where/2","title":"Markov.Database.Weight.where/2","type":"macro"},{"doc":"Write the record to the table, see mnesia:dirty_write . Missing fields tagged as autoincrement will be incremented with the counter if nil .","ref":"Markov.Database.Weight.html#write!/1","title":"Markov.Database.Weight.write!/1","type":"function"},{"doc":"Write the record to the table, see mnesia:write . Missing fields tagged as autoincrement will be incremented with the counter if nil .","ref":"Markov.Database.Weight.html#write/2","title":"Markov.Database.Weight.write/2","type":"function"},{"doc":"","ref":"Markov.Database.Weight.html#t:autoincrement/0","title":"Markov.Database.Weight.autoincrement/0","type":"type"},{"doc":"","ref":"Markov.Database.Weight.html#t:t/0","title":"Markov.Database.Weight.t/0","type":"type"},{"doc":"Loads the dictionary for prompt generation into a ets table","ref":"Markov.DictionaryHolder.html","title":"Markov.DictionaryHolder","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Markov.DictionaryHolder.html#child_spec/1","title":"Markov.DictionaryHolder.child_spec/1","type":"function"},{"doc":"Callback implementation for GenServer.init/1 .","ref":"Markov.DictionaryHolder.html#init/1","title":"Markov.DictionaryHolder.init/1","type":"function"},{"doc":"","ref":"Markov.DictionaryHolder.html#start_link/1","title":"Markov.DictionaryHolder.start_link/1","type":"function"},{"doc":"","ref":"Markov.ListUtil.html","title":"Markov.ListUtil","type":"module"},{"doc":"Splits the list into size -sized lists of consecutive elements Example iex&gt; Markov.ListUtil . overlapping_stride ( [ :a , :b , :c , :d , :e , :f , :g ] , 3 ) [ [ :a , :b , :c ] , [ :b , :c , :d ] , [ :c , :d , :e ] , [ :d , :e , :f ] , [ :e , :f , :g ] ] iex&gt; Markov.ListUtil . overlapping_stride ( [ :a , :b , :c , :d , :e , :f , :g ] , 2 ) [ [ :a , :b ] , [ :b , :c ] , [ :c , :d ] , [ :d , :e ] , [ :e , :f ] , [ :f , :g ] ]","ref":"Markov.ListUtil.html#overlapping_stride/2","title":"Markov.ListUtil.overlapping_stride/2","type":"function"},{"doc":"Performs training, generation and probability shifting. Supposed to only ever be used by Markov.ModelServer s.","ref":"Markov.ModelActions.html","title":"Markov.ModelActions","type":"module"},{"doc":"Adjust the probabilities of a batch of connections","ref":"Markov.ModelActions.html#adjust_batch_probs/1","title":"Markov.ModelActions.adjust_batch_probs/1","type":"function"},{"doc":"Adjusts the probability of one connection","ref":"Markov.ModelActions.html#adjust_one_prob/1","title":"Markov.ModelActions.adjust_one_prob/1","type":"function"},{"doc":"","ref":"Markov.ModelActions.html#generate/2","title":"Markov.ModelActions.generate/2","type":"function"},{"doc":"","ref":"Markov.ModelActions.html#next_state/3","title":"Markov.ModelActions.next_state/3","type":"function"},{"doc":"","ref":"Markov.ModelActions.html#nuke/1","title":"Markov.ModelActions.nuke/1","type":"function"},{"doc":"processes { , :score, } tag queries","ref":"Markov.ModelActions.html#process_scores/3","title":"Markov.ModelActions.process_scores/3","type":"function"},{"doc":"tag query to match specification","ref":"Markov.ModelActions.html#tq2ms/2","title":"Markov.ModelActions.tq2ms/2","type":"function"},{"doc":"tag query to match spec condition","ref":"Markov.ModelActions.html#tq2msc/1","title":"Markov.ModelActions.tq2msc/1","type":"function"},{"doc":"","ref":"Markov.ModelActions.html#train/3","title":"Markov.ModelActions.train/3","type":"function"},{"doc":"","ref":"Markov.ModelActions.html#walk_chain/5","title":"Markov.ModelActions.walk_chain/5","type":"function"},{"doc":"GenServer in charge of one model","ref":"Markov.ModelServer.html","title":"Markov.ModelServer","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Markov.ModelServer.html#child_spec/1","title":"Markov.ModelServer.child_spec/1","type":"function"},{"doc":"Callback implementation for GenServer.init/1 .","ref":"Markov.ModelServer.html#init/1","title":"Markov.ModelServer.init/1","type":"function"},{"doc":"","ref":"Markov.ModelServer.html#start/1","title":"Markov.ModelServer.start/1","type":"function"},{"doc":"","ref":"Markov.ModelServer.html#start_link/1","title":"Markov.ModelServer.start_link/1","type":"function"},{"doc":"","ref":"Markov.ModelServer.html#t:start_options/0","title":"Markov.ModelServer.start_options/0","type":"type"},{"doc":"","ref":"Markov.ModelServer.State.html","title":"Markov.ModelServer.State","type":"module"},{"doc":"","ref":"Markov.ModelServer.State.html#t:t/0","title":"Markov.ModelServer.State.t/0","type":"type"},{"doc":"","ref":"Markov.Operation.html","title":"Markov.Operation","type":"module"},{"doc":"","ref":"Markov.Operation.html#t:t/0","title":"Markov.Operation.t/0","type":"type"},{"doc":"Thin wrapper around Markov to make the chain respond to prompts assuming it's been trained on the appropriate data","ref":"Markov.Prompt.html","title":"Markov.Prompt","type":"module"},{"doc":"Generates the text from a prompt","ref":"Markov.Prompt.html#generate_prompted/3","title":"Markov.Prompt.generate_prompted/3","type":"function"},{"doc":"Assuming your application receives a stream of strings, call this function instead of Markov.train/3 with the current and last string","ref":"Markov.Prompt.html#train/4","title":"Markov.Prompt.train/4","type":"function"},{"doc":"Trains the model on a list of consecutive strings","ref":"Markov.Prompt.html#train_on_list/2","title":"Markov.Prompt.train_on_list/2","type":"function"},{"doc":"Main supervisor","ref":"Markov.Sup.html","title":"Markov.Sup","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Markov.Sup.html#child_spec/1","title":"Markov.Sup.child_spec/1","type":"function"},{"doc":"","ref":"Markov.Sup.html#start_link/1","title":"Markov.Sup.start_link/1","type":"function"},{"doc":"","ref":"Markov.Sup.html#stop/0","title":"Markov.Sup.stop/0","type":"function"},{"doc":"","ref":"Markov.TextUtil.html","title":"Markov.TextUtil","type":"module"},{"doc":"Strips textual tokens of preceding and trailing non-word characters and downcases them iex&gt; Markov.TextUtil . sanitize_token ( :atom ) :atom iex&gt; Markov.TextUtil . sanitize_token ( &quot;test&quot; ) &quot;test&quot; iex&gt; Markov.TextUtil . sanitize_token ( &quot; !!!???/// tEsT &gt;&gt;&gt;&quot; ) &quot;test&quot;","ref":"Markov.TextUtil.html#sanitize_token/1","title":"Markov.TextUtil.sanitize_token/1","type":"function"},{"doc":"Text generation library based on nth-order Markov chains","ref":"readme.html","title":"Markov","type":"extras"},{"doc":"Token sanitation (optional): ignores letter case and punctuation when switching states, but still keeps the output as-is Operation history (optional): recalls the operations it was instructed to perform, incl. past training data Probability shifting (optional): gives less popular generation paths more chance to get used, which makes the output more original but may produce nonsense Tagging (optional): you can tag your source data to be queried later by aggregating those tags in any way you want, kind of like a database Context awareness (optional) grants your model the ability to answer questions given to it provided training data is good enough Managed disk storage Transparent fragmentation reduces RAM usage and loading times with huge models","ref":"readme.html#features","title":"Markov - Features","type":"extras"},{"doc":"In mix.exs : defp deps do [ { :markov , &quot;~&gt; 3.0&quot; } ] end Before using for the first time: $ mix amnesia.create -d Markov.Database --disk Unlike Markov 1.x, this version has very strong opinions on how you should create and persist your models (that differs from 2.x). Example workflow (click here for full docs): # The name can be an arbitrary term (not just a string). # It will be stored in a Mnesia DB and created from scratch using the specified # parameters if not found. # You should configure mnesia if you want to change its working dir, e.g.: # `config :mnesia, dir: &quot;/var/data&quot;` { :ok , model } = Markov . load ( &quot;model_name&quot; , sanitize_tokens : true , store_log : [ :train ] ) # train using four strings :ok = Markov . train ( model , &quot;hello, world!&quot; ) :ok = Markov . train ( model , &quot;example string number two&quot; ) :ok = Markov . train ( model , &quot;hello, Elixir!&quot; ) :ok = Markov . train ( model , &quot;fourth string&quot; ) # generate text { :ok , text } = Markov . generate_text ( model ) IO . puts ( text ) # commit all changes and unload Markov . unload ( model ) # these will return errors because the model is unloaded # Markov.generate_text(model) # Markov.train(model, &quot;hello, world!&quot;) # load the model again { :ok , model } = Markov . load ( &quot;/base/directory&quot; , &quot;model_name&quot; ) # enable probability shifting and generate text :ok = Markov . configure ( model , shift_probabilities : true ) { :ok , text } = Markov . generate_text ( model ) IO . puts ( text ) # print uninteresting stats model |&gt; Markov . dump_partition ( 0 ) |&gt; IO . inspect model |&gt; Markov . read_log |&gt; IO . inspect # this will also write our new just-set option Markov . unload ( model )","ref":"readme.html#usage","title":"Markov - Usage","type":"extras"},{"doc":"The English dictionary in a CSV format","ref":"readme.html#credits","title":"Markov - Credits","type":"extras"}]